import java.awt.*;
import java.io.*;

class ListModule 
{
	class Node {
		Module M;
		Node next;
	}

	Node root = null;
	int count = 0;

	public void add(Module M) {
		Node N = new Node();
		if (M.n==-1) M.n = count++;
		else if (M.n>=count) count = M.n+1;
		N.M = M;
		N.next = root;
		root = N;
	}

	public void remove(Module M) {
		Node N=root,O=null;
		while (N!=null) {
			if (N.M==M) {
				if (O==null) root=N.next;
				else O.next=N.next;
			} else
				O = N;
			N = N.next;
		}
	}

	public int count() {
		int c = 0;
		Node N=root;
		while (N!=null) {
			c++;
			N = N.next;
		}
		return c;
	}

	public void draw(Graphics g) {
		Node N = root;
		while (N!=null) {
			N.M.draw(g);
			N = N.next;
		}
	}

	public Module get(int n) {
		Node N = root;
		while (N!=null) {
			if (N.M.n==n) return N.M;
			N = N.next;
		}
		return null;
	}

	/** returns the first module that is in the area */
	public Module findModule(Pt p) {
		Node N = root;
		while (N!=null) {
			if (N.M.inArea(p)) return N.M;
			N = N.next;
		}
		return null;
	}

	/** Find module IO tags */
	public Module findModuleIO(Pt p) {
		Node N = root;
		while (N!=null) {
			if (N.M.nearIO(p)) return N.M;
			N = N.next;
		}
		return null;
	}

	/** Gets the module to be rendered first */
	public Module findRootModule() {
		Module MyRoot = null;
		Node N = root;
		while (N!=null) {
			if (!Const.proj.links.linkTo(N.M,-1)) {
				if (MyRoot!=null) return null;
				MyRoot = N.M;
			}
			N = N.next;
		}
		return MyRoot;
	}

	public void setUnused() {
		Node N = root;
		while (N!=null) {
			N.M.used = false;
			N = N.next;
		}
	}

	private int orderRecurse(Module M,Module[] MS,int c) throws Exception {
		if (M.used) return c;
		// add this module + set as used
		MS[c] = M;
		MS[c].used = true;
		c++;
		// scan back through modules
		for (int x=0;x<M.inputcount;x++) {
			Module NXT = Const.proj.links.getLink(M,x);
			if (NXT==null) throw new Exception("No Input on Module");
			c = orderRecurse(NXT,MS,c);
		}
		return c;
	}

	public Module[] orderModules() throws Exception {
		setUnused();
		Module MS[] = new Module[count()];
		Module M = findRootModule();
		if (M==null) throw new Exception("Only ONE root module allowed");
		int c = 0;
		c = orderRecurse(M,MS,c);
		return MS;
	}

	public void load(BufferedReader F) throws Exception {
		Module M = new Module();
		M.load(F);
		add(M);
	}

	public void save(BufferedWriter F) throws Exception {
		Node N = root;
		while (N!=null) {
			F.write("MODULE:\n");
			N.M.save(F);
			N = N.next;
		}
	}
}
