import java.awt.*;
import java.util.*;
import java.io.*;
import javax.imageio.*;

class Module 
{
	public String NAME="[NO NAME]";		// R4 ID
	public String filename;		// The file this was originally loaded from
	public int n = -1;			// The UNIQUE number of this module

	public Pt pos= new Pt();	// Position on Screen
	public int IOnum;			// number of nearest point of IO after calling nearIO

	public boolean used;
	public int inputcount;

	Properties props;
	Image icon;				// the icon of this module
	
	String[] idInput;
	String[] idModule;
	String[] idVar;
	String[] idFunc;


	Module() {
		pos.x = 64;
		pos.y = 64;
	}

	public void loadFile(String _filename) throws Exception {
	  filename = _filename;
      props = new Properties();
      props.load(new FileInputStream(new File(Const.MODULEDIR+filename)));
	  NAME = getPropS("NAME","[NO NAME]");
	  icon = ImageIO.read(new File(Const.MODULEDIR+getPropS("ICON","unknown.png")));
	  inputcount = getPropI("INPUT_C",0);
	  idFunc = new String[getPropI("FUNC_C",0)];
	  for (int x=0;x<idFunc.length;x++)
		  idFunc[x] = getPropS("FUNC_"+(x+1)+"_DEF","");
	}

	public void draw(Graphics g) {
		g.setColor(Color.BLACK);
		g.drawImage(icon,pos.x-32,pos.y-32,null);
		g.drawRect(pos.x-32,pos.y-32,64,64);
		g.drawString(NAME,pos.x-32,pos.y-35);
		// draw input tags
		g.setColor(Color.RED);
		for (int i=-1;i<inputcount;i++) {
			Pt P = getIO(i);
			g.drawRect(P.x-3,P.y-3,6,6);
		}
	}

	public String getPropS(String key,String def) {
		return props.getProperty(key,def);
	}

	public int getPropI(String key,int def) {
		int n = def;
		try {
			n = Integer.parseInt(getPropS(key,def+""));
		} catch (Exception E) {
		}
		return n;
	}

	public boolean inArea(Pt p) {
		return (pos.x>p.x-32)&&(pos.y>p.y-32)&&(pos.x<p.x+32)&&(pos.y<p.y+32);
	}

	public boolean nearIO(Pt p) {
		Pt pt;
		for (int i=-1;i<inputcount;i++) {
			pt = getIO(i);
			if (p.dist(pt)<4) {
				IOnum = i;
				return true;
			}
		}
		return false;
	}

	public Pt getIO(int n) {
		if (n==-1) return pos.add(40,0);
		if (n>=0) return pos.add(-40,(n*12)-28);
		return null;
	}

	public void load(BufferedReader F) throws Exception {
		loadFile(F.readLine());
		n = Integer.parseInt(F.readLine());
		pos = Pt.fromString(F.readLine());
		for (int f=0;f<idFunc.length;f++) 
			idFunc[f] = F.readLine();
	}

	public void save(BufferedWriter F) throws Exception {
		F.write(filename+"\n");
		F.write(n+"\n");
		F.write(pos.toString()+"\n");
		for (int f=0;f<idFunc.length;f++) 
			F.write(idFunc[f]+"\n");
	}

	/** Get the key, and replace all the predefined names */
	public String replaceText(String key) throws Exception {
		String v = getPropS(key,"[ERROR]");
		if (v.equals("[ERROR]")) throw new Exception("Key ["+key+"] not found");
		// check for presence of input names
		int x,c=getPropI("INPUT_C",0);
		for (x=0;x<c;x++) {
			String rv = getPropS("INPUT_"+(x+1),"[ERROR]");
			int p = v.indexOf(rv);
			while (p>=0) {
				v = v.substring(0,p)+idInput[x]+v.substring(p+rv.length(),v.length());
				p = v.indexOf(rv,p);
			}
		}
		c=getPropI("MODULE_C",0);
		for (x=0;x<c;x++) {
			String rv = getPropS("MODULE_"+(x+1),"[ERROR]");
			int p = v.indexOf(rv);
			while (p>=0) {
				v = v.substring(0,p)+idModule[x]+v.substring(p+rv.length(),v.length());
				p = v.indexOf(rv,p);
			}
		}
		c=getPropI("VAR_C",0);
		for (x=0;x<c;x++) {
			String rv = getPropS("VAR_"+(x+1),"[ERROR]");
			int p = v.indexOf(rv);
			while (p>=0) {
				v = v.substring(0,p)+idVar[x]+v.substring(p+rv.length(),v.length());
				p = v.indexOf(rv,p);
			}
		}
		c=getPropI("FUNC_C",0);
		for (x=0;x<c;x++) {
			String rv = getPropS("FUNC_"+(x+1),"[ERROR]");
			int p = v.indexOf(rv);
			while (p>=0) {
				v = v.substring(0,p)+idFunc[x]+v.substring(p+rv.length(),v.length());
				p = v.indexOf(rv,p);
			}
		}
		return v;
	}
}
