import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.imageio.*;
import java.io.*;
import javax.swing.*;

public class WinFunc extends JFrame implements ActionListener,WindowListener {
	Image img;

	int fCount=0;
	Module fMod;
	JLabel[] fLab;
	JTextField[] fText;

	public WinFunc() {
		super("Functions");
		setSize(256,256);
		setLocation(512,256);
		setResizable(true);

		setModule(null);

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container C = getContentPane();
		addWindowListener(this);
	}

	public void setModule(Module M) {
		fMod = M;
		setTitle((M==null)?"No Module":M.NAME);
		if (M!=null) fCount = M.idFunc.length;
		else fCount = 0;
		fLab = new JLabel[fCount];
		fText = new JTextField[fCount];
		Container C = getContentPane();
		C.removeAll();
		C.setLayout(new GridLayout(fCount,2));
		for (int f=0;f<fCount;f++) {
			fLab[f] = new JLabel(M.getPropS("FUNC_"+(f+1)+"_NAME","?"));
			fText[f] = new JTextField(M.idFunc[f]);
			fText[f].addActionListener(this);
			C.add(fLab[f]);
			C.add(fText[f]);
		}
		C.validate();
		paint(getGraphics());
	}

	public void paint(Graphics g) {
		super.paint(g);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() instanceof JTextField) {
			JTextField TF = (JTextField)e.getSource();
			int n=findText(TF);
			if (n>=0) {
				fMod.idFunc[n] = TF.getText();
			}
		}
	}

	int findText(JTextField F) {
		for (int f=0;f<fText.length;f++)
			if (fText[f]==F) return f;
		return -1;
	}

	// -----------------------------------------------------------
	public void windowActivated(WindowEvent e) {}
	public void windowClosed(WindowEvent e) {}
	public void windowClosing(WindowEvent e) {
		Const.proj.onExit();
	}
	public void windowDeactivated(WindowEvent e) {}
	public void windowDeiconified(WindowEvent e) {}
	public void windowIconified(WindowEvent e) {} 
	public void windowOpened(WindowEvent e) {}

}